/**
 * @file    smart.h
 * @brief   read S.M.A.R.T values
 * @author  hendrik schutter
 * @date    01.05.2020
 */

#ifndef SMART_H_
#define SMART_H_

#include "reHDD.h"

class SMART
{
protected:

public:
    static void readSMARTData(Drive* drive);

private:
    SMART(void);

    static void parseModelFamily(string sLine);
    static void parseModelName(string sLine);
    static void parseSerial(string sLine);
    static void parseCapacity(string sLine);
    static void parseErrorCount(string sLine);
    static void parsePowerOnHours(string sLine);
    static void parsePowerCycle(string sLine);

    static  string modelFamily;
    static  string modelName;
    static  string serial;
    static  uint64_t capacity;
    static  uint32_t errorCount;
    static  uint32_t powerOnHours;
    static  uint32_t powerCycle;
};

#endif  // SMART_H_